#include <stdio.h>
#include <stdlib.h>

struct __node
{
	struct __node *next;
	int data;
};

void free_ll(struct __node *node)
{
	if(node->next != NULL)
		free_ll(node->next);
	free(node);

	return;
}

void print_ll(struct __node *node)
{
	if(node != NULL)
	{
		printf("[%d] ", node->data);
		print_ll(node->next);
	}
	else
		printf("\n");

	return;
}

int main()
{
	struct __node *head = NULL;
	struct __node *current = NULL;
	int data;

	printf("Enter an integer, 0 will end it: ");
	scanf("%d", &data);

	if(data)
	{
		head = (struct __node *) malloc((unsigned) sizeof(struct __node));
		current = head;
	}

	while(data)
	{
		current->data = data;
		printf("Enter an integer, 0 will end it: ");
		scanf("%d", &data);

		if(data)
		{
			current->next = (struct __node *) malloc((unsigned) sizeof(struct __node));
			current = current->next;
		}
		else
			current->next = NULL;
	}

	current = head;

	print_ll(head);

	if(head != NULL)
		free_ll(head);

	current = head = NULL;

	print_ll(current);

	exit(0);
}


